Index: abi/include/_bits/__noreturn.h
===================================================================
--- abi/include/_bits/__noreturn.h	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
+++ abi/include/_bits/__noreturn.h	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2018 CZ.NIC, z.s.p.o.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+ * Authors:
+ *	Jiří Zárevúcky (jzr) <zarevucky.jiri@gmail.com>
+ */
+
+/** @addtogroup bits
+ * @{
+ */
+/** @file
+ * Definition of __noreturn.
+ *
+ * Expands to the most appropriate noreturn attribute for a given language.
+ */
+
+#ifndef _BITS_NORETURN_H_
+#define _BITS_NORETURN_H_
+
+#ifndef __noreturn
+
+#if __cplusplus >= 201103L
+#define __noreturn  [[noreturn]]
+#elif __STDC_VERSION__ >= 201112L
+#define __noreturn  _Noreturn
+#elif (__GNUC__ >= 3) || (defined(__clang__) && __has_attribute(noreturn))
+#define __noreturn __attribute__((noreturn))
+#else
+#define __noreturn
+#endif
+
+#endif
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/generic/async/server.c
===================================================================
--- uspace/lib/c/generic/async/server.c	(revision 1c9ae081d3be419212f0b575c110ed14002ff5f8)
+++ uspace/lib/c/generic/async/server.c	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
@@ -1847,5 +1847,5 @@
 }
 
-_Noreturn void async_manager(void)
+__noreturn void async_manager(void)
 {
 	futex_lock(&async_futex);
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 1c9ae081d3be419212f0b575c110ed14002ff5f8)
+++ uspace/lib/c/include/async.h	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
@@ -51,4 +51,6 @@
 #include <abi/cap.h>
 
+#include <_bits/__noreturn.h>
+
 typedef sysarg_t aid_t;
 typedef sysarg_t port_id_t;
@@ -108,5 +110,5 @@
 typedef struct async_exch async_exch_t;
 
-extern _Noreturn void async_manager(void);
+extern __noreturn void async_manager(void);
 
 #define async_get_call(data) \
Index: uspace/lib/c/include/futex.h
===================================================================
--- uspace/lib/c/include/futex.h	(revision 1c9ae081d3be419212f0b575c110ed14002ff5f8)
+++ uspace/lib/c/include/futex.h	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
@@ -45,5 +45,5 @@
 	atomic_t val;
 #ifdef CONFIG_DEBUG_FUTEX
-	_Atomic void *owner;
+	void *owner;
 #endif
 } futex_t;
Index: uspace/lib/c/include/setjmp.h
===================================================================
--- uspace/lib/c/include/setjmp.h	(revision 1c9ae081d3be419212f0b575c110ed14002ff5f8)
+++ uspace/lib/c/include/setjmp.h	(revision 6b96dc0602d163aad5e3e62cd3ee618519b371c5)
@@ -35,12 +35,13 @@
 
 #include <libarch/fibril_context.h>
+#include <_bits/__noreturn.h>
 
 typedef context_t jmp_buf[1];
 
 extern int __setjmp(jmp_buf) __attribute__((returns_twice));
-extern _Noreturn void __longjmp(jmp_buf, int);
+extern __noreturn void __longjmp(jmp_buf, int);
 
 #define setjmp __setjmp
-extern _Noreturn void longjmp(jmp_buf, int);
+extern __noreturn void longjmp(jmp_buf, int);
 
 #endif
